package com.uas.platform.b2b.manage.utils;

import org.springframework.security.crypto.codec.Hex;

import javax.crypto.*;
import javax.crypto.spec.SecretKeySpec;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;

/**
 * 加密工具
 *
 * @author hejq
 * @date 2018/9/5 22:29
 */
public class EncryptUtils {

    /**
     * 加密规则
     */
    private static final String KEY = "587e6f52-fc99-49d6-ae21-da97bd89fe70";

    /**
     * 算法
     */
    private static final String ALGORITHM = "AES";

    /**
     * 编码
     *
     */
    private static final String CODE_STYLE = "UTF-8";

    /**
     * 加密
     *  <pre>
     *      1.根据指定算法AES自成密码器
     *      2.初始化密码器，第一个参数为加密(Encrypt_mode)或者解密解密(Decrypt_mode)操作，第二个参数为使用的KEY
     *      3.获取加密内容的字节数组(这里要设置为utf-8)不然内容中如果有中文和英文混合中文就会解密为乱码
     *      4.根据密码器的初始化方式--加密：将数据加密
     *      5.将加密后的数据转换为字符串
     *  </pre>
     * @param content 需要加密的内容
     * @return 加密后的字符串
     */
    public static String aesEncode(String content){
        try {
            SecretKey key = createSecretKey();

            //1.根据指定算法AES自成密码器
            Cipher cipher = Cipher.getInstance(ALGORITHM);

            //2.初始化密码器，第一个参数为加密(Encrypt_mode)或者解密解密(Decrypt_mode)操作，第二个参数为使用的KEY
            cipher.init(Cipher.ENCRYPT_MODE, key);

            //3.获取加密内容的字节数组(这里要设置为utf-8)不然内容中如果有中文和英文混合中文就会解密为乱码
            byte [] byteEncode = content.getBytes(CODE_STYLE);

            //4.根据密码器的初始化方式--加密：将数据加密
            byte [] byteAes = cipher.doFinal(byteEncode);

            //5.将加密后的数据转换为字符串
            //这里用Base64Encoder中会找不到包
            //解决办法：
            //在项目的Build path中先移除JRE System Library，再添加库JRE System Library，重新编译后就一切正常了。

            String aesEncode = new String(Hex.encode(byteAes));

            //11.将字符串返回
            return aesEncode;
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        } catch (NoSuchPaddingException e) {
            e.printStackTrace();
        } catch (InvalidKeyException e) {
            e.printStackTrace();
        } catch (IllegalBlockSizeException e) {
            e.printStackTrace();
        } catch (BadPaddingException e) {
            e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //如果有错就返回null
        return null;
    }

    /**
     * 解密
     * <pre>
     *     解密过程：
     *     1.同加密1-4步
     *     2.将加密后的字符串反纺成byte[]数组
     *     3.将加密内容解密
     * </pre>
     * @param content 加密内容
     * @return 解密后的数据
     */
    public static String aesDecode(String content){
        try {

            SecretKey key = createSecretKey();

            //1.根据指定算法AES自成密码器
            Cipher cipher = Cipher.getInstance("AES");

            //2.初始化密码器，第一个参数为加密(Encrypt_mode)或者解密(Decrypt_mode)操作，第二个参数为使用的KEY
            cipher.init(Cipher.DECRYPT_MODE, key);

            //3.将加密并编码后的内容解码成字节数组
            byte [] byteContent = Hex.decode(content);

            /*
             * 解密
             */
            byte [] byteDecode = cipher.doFinal(byteContent);
            String aesDecode = new String(byteDecode, CODE_STYLE);
            return aesDecode;
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        } catch (NoSuchPaddingException e) {
            e.printStackTrace();
        } catch (InvalidKeyException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (IllegalBlockSizeException e) {
            e.printStackTrace();
        } catch (BadPaddingException e) {
            e.printStackTrace();
        }

        //如果有错就返回null
        return null;
    }

    /**
     * 构造密钥生成器
     * <pre>
     *     1.构造密钥生成器
     *     2.根据ecnodeRules规则初始化密钥生成器
     *     3.产生密钥
     *     4.创建和初始化密码器
     *     5.内容加密
     *     6.返回字符串
     * </pre>
     * @return SecretKey
     * @throws NoSuchAlgorithmException
     * @throws UnsupportedEncodingException
     */
    public static SecretKey createSecretKey() throws NoSuchAlgorithmException, UnsupportedEncodingException {

        //1.构造密钥生成器，指定为AES算法,不区分大小写
        KeyGenerator keygen = KeyGenerator.getInstance(ALGORITHM);

        //2.根据KEY初始化密钥生成器，生成一个128位的随机源,根据传入的字节数组
        SecureRandom random = new SecureRandom(KEY.getBytes(CODE_STYLE));

        keygen.init(128, random);

        //3.产生原始对称密钥
        SecretKey originalKey = keygen.generateKey();

        //4.获得原始对称密钥的字节数组
        byte [] raw = originalKey.getEncoded();

        //5.根据字节数组生成AES密钥
        SecretKey key = new SecretKeySpec(raw, ALGORITHM);

        return key;
    }
}
